///////////////////////////////////////////////////////////////////////////////
/// \file  tipos.h
/// \brief Archivo de cabecera que contiene los tipos definidos necesarios
///        para las distintas partes de la librera
///
/// <b>F.Creacin:</b>  19 de junio de 2006          <br>
/// <b>Autor:     </b>  Francisco Jos Gallego Durn <br>
///////////////////////////////////////////////////////////////////////////////

// Cosas para que la cabecera no se incluya ms de una vez
#ifndef __SR_TIPOS_H__
#define __SR_TIPOS_H__

//#if _MSC_VER > 1000
//#pragma once
//#endif

/// Includes
///
#include <vector>
#include <cstdlib>
#include <ctime>

using namespace std;

/// TIPOS DEFINIDOS
///
typedef vector<int>    TVecInts;
typedef vector<double> TVecDoubles;

/// Funciones de utilidad
///
double RandomDouble (double min, double max);
int    RandomInt (int min, int max);
void   GenerarSemillaRandom();

#endif
